<template>
  <v-container v-if="movies.length === 0">
    <div class="text-xs-center">
      <h2>No movies found.</h2>
    </div>
  </v-container>

  <v-container v-else grid-list-xl>
    <v-layout wrap>
      <v-container grid-list-xl>
        <v-layout wrap>
          <v-flex xs3 v-for="(movie, index) in movies" :key="index" mb-2>
            <BaseMovieListItem
              :movie="movie"
              @getMovieDetails="goToMovie"
              @addToFavorites="addToFavorites"
              @removeFromFavorites="removeFromFavorites"
            />
          </v-flex>
        </v-layout>
      </v-container>
    </v-layout>
  </v-container>
</template>

<script>
import BaseMovieListItem from '@/components/presentation/BaseMovieListItem';
import { mapActions } from 'vuex';

export default {
  name: 'MovieListContainer',
  props: {
    movies: {
      type: Array,
      required: true
    }
  },
  data() {
    return {};
  },
  components: {
    BaseMovieListItem
  },
  computed: {},
  methods: {
    ...mapActions({
      addMovieToFavorites: 'movies/addToFavorites',
      removeMovieFromFavorites: 'movies/removeFromFavorites'
    }),
    goToMovie(id) {
      this.$router.push('/movie/' + id);
    },
    addToFavorites(movie) {
      movie.isFavorite = true;
      this.addMovieToFavorites(movie);
    },
    removeFromFavorites(movie) {
      movie.isFavorite = false;
      this.removeMovieFromFavorites(movie);
    }
  }
};
</script>
